﻿using HardwareShopDatabaseImplement.Models;
using Microsoft.EntityFrameworkCore;

namespace HardwareShopDatabaseImplement
{
    public class HardwareShopDatabase : DbContext
    {
        protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
        {
            if (optionsBuilder.IsConfigured == false)
            {
                optionsBuilder.UseSqlServer(@"Data Source=DESKTOP-SINQU55\SQLEXPRESS;Initial Catalog=HardwareShopDatabase;Integrated Security=True;MultipleActiveResultSets=True;;TrustServerCertificate=True");
            }
            base.OnConfiguring(optionsBuilder);
        }

        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            modelBuilder.Entity<BuildComponent>().HasKey(x => new { x.ComponentId, x.BuildID });
            modelBuilder.Entity<PurchaseBuild>().HasKey(x => new { x.PurchaseID, x.BuildID });
            modelBuilder.Entity<PurchaseGood>().HasKey(x => new { x.PurchaseID, x.GoodID });
        }

        public virtual DbSet<Build> Builds { set; get; }

        public virtual DbSet<Comment> Comments { set; get; }

        public virtual DbSet<Component> Components { set; get; }

        public virtual DbSet<Good> Goods { set; get; }

        public virtual DbSet<Order> Orders { set; get; }

        public virtual DbSet<Purchase> Purchase { set; get; }

        public virtual DbSet<PurchaseBuild> PurchasesBuilds { set; get; }

        public virtual DbSet<PurchaseGood> PurchasesGoods { set; get; }

        public virtual DbSet<User> Users { set; get; }
    }
}